// declarations

#include <gl\gl.h>
#include <gl\glu.h>

void cross( float *v1, float *v2, float *cross );
float dot( float *v1, float *v2);
int isZero(float s) ;           //to compear abs value with 0
float Norm(float *v);


// s is intersection point
// lambda is parameter to intersection point
// a and ab is point on line and direction of line
// planeNormal and planePoint are normal to plane and point on plane

void line_and_plane(float *s, float *lambda, int parallel, 
					float *a, float *ab, float *planeNormal, 
					float *planePoint);

// to check if edge vertices are on different sides of plane
int ifIntersect(float *Qi, float *Qii, float *planeNormal, 
				                          float *planePoint);
void normalize(float *v);
float trArea(float *p0, float *p1, float *p2);
inline float det(float *row1, float *row2, float *row3);
void trNormal(float *p0, float *p1, float *p2, float *n);
void MatrByVect(float M[16], float v[4], float res[4]);

void trlOrtho(float *p0,  float *p1, float *p2, float *centroid);
float getAngle (float *v1, float *v2);
float dist(float *p1, float *p2);
void vector(float *p1, float *p2, float *v);

typedef float  MATRIX3X3[3][3];

void UnitMatrix(MATRIX3X3 &m);
void ZeroMatrix(MATRIX3X3 &m);
void CopyMatrix(MATRIX3X3 &dst, MATRIX3X3 &src);
void ScaleMatrix(MATRIX3X3 &dst, float &scale, MATRIX3X3 &src);
void TransposeMatrix(MATRIX3X3 &dst, MATRIX3X3 &src);
void MultMatrix(MATRIX3X3 &product, MATRIX3X3 &m1, MATRIX3X3 &m2);
void Transform(polyData *model, MATRIX3X3 &m);

