// polyData.h: interface for the polyData class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POLYDATA_H__607DCE03_BEE6_11D4_B299_0000F45E136F__INCLUDED_)
#define AFX_POLYDATA_H__607DCE03_BEE6_11D4_B299_0000F45E136F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "LList.h"

class polyData  
{

  struct IncidentTrs
  {
	int *pointNei;
	int numNei;
  };

  struct boundbox
  {
	float Xmin, Xmax;
	float Ymin, Ymax;
	float Zmin, Zmax;
  };


public:
	
  float **Points;        //pointer to array of pointers
  int **Triangles; 
  IncidentTrs *Neis;        //keep a incident triangles ids
  int numTrs, numPts;
  boundbox box;
  float *nbhdArea;  // sum of the surface areas of all 
                     //the triangles incident to a vertex
  float *trsArea;    //area of triangles

  polyData();
  polyData(int numPts, int numTrs);
  virtual ~polyData();

  void SetNumPoints(int numPts);
  void SetNumTrs(int numTrs);
  void allocatePoints(int numPts);
  void allocatePolys(int numPolys);
  void setPoint(int i, float p3[]);
  void setTriangle(int i, int tr[3]);
  int GetPointId(int trId, int trVertId);
  void GetPoint(int trId, int trVertId, float *p);
  void makeBoundBox();
  void Translate2Origin();
  void BuildLinks( );  //to find incident triangles for  all points
  void InitModel();
  void copyPointsFrom(polyData *dataIn);
  void copyTrianglesFrom(polyData *dataIn);
  void Clear();
  void trlCircleNei(int trId, LList* nei);

//after CircleNie are build
  int GetEdgeNei(int p1, int p2, int *nei);              //return the number of 
                                                //all trs shearing [p1,p2] edge
  int ifConsistient(int trId1, int vert1, int vert2, int trId2);
  void orient();                                //make model consistient
  void ReverseOrientation();                             // reverse  model orientation                 
  void reverseTr(int trId);
  int incidentVts(int ptId, LList *nei);   //ordered 1st neighbors 
  int isEdge(int p1, int p2);
  void getAreas();
  int TraversAndOrder(int trId);
  BOOL isBoundaryEdge(int p1, int p2);

};

#endif // !defined(AFX_POLYDATA_H__607DCE03_BEE6_11D4_B299_0000F45E136F__INCLUDED_)
