// softDoc.cpp : implementation of the CSoftDoc class
//

#include "stdafx.h"
#include "soft.h"
#include "softDoc.h"

#include "math.h"
#include "includes.h"
#include "softView.h"
#include "fileManager.h"
#include "Diffusion.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSoftDoc


IMPLEMENT_DYNCREATE(CSoftDoc, CDocument)

BEGIN_MESSAGE_MAP(CSoftDoc, CDocument)
	//{{AFX_MSG_MAP(CSoftDoc)
	ON_COMMAND(ID_DIFFUSION, OnDiffusion)
	//}}AFX_MSG_MAP

	ON_UPDATE_COMMAND_UI(ID_INDICATOR_MODEL, OnUpdateModelInfo)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSoftDoc construction/destruction

CSoftDoc::CSoftDoc()
{
	// TODO: add one-time construction code here
	modelPtr = NULL;
    feature = NULL;
    fileMngr = NULL;	
    modelCurv = NULL;
    m_modelInfo.Format("No data loaded");

}

CSoftDoc::~CSoftDoc()
{
  if (modelPtr != NULL)
  {
   delete modelPtr;
  }
  
  if (fileMngr!= NULL)
  {
    delete fileMngr;
  }

  if (feature != NULL)
  {
    delete feature;
  }
	
  if (modelCurv != NULL)
	{
	  delete modelCurv;
	}

}

BOOL CSoftDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CSoftDoc serialization

void CSoftDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}


void CSoftDoc::OnUpdateModelInfo(CCmdUI *pCmdUI)
{
   pCmdUI->Enable();
   pCmdUI->SetText(m_modelInfo);
}


void CSoftDoc::ClearDoc() 
{
	// TODO: Add your specialized code here and/or call the base class

	if ( this->modelPtr != NULL)
	{
      delete this->modelPtr;
      this->modelPtr = NULL;
	}
 	
	if (this->fileMngr != NULL)
	{
      delete this->fileMngr;
      this->fileMngr = NULL;
	}

    if (this->feature != NULL)
	{
	  delete this->feature;
      this->feature = NULL;
	}
	  
	if (this->modelCurv != NULL)
	  {
		 delete this->modelCurv;
         this->modelCurv = NULL;
	  }
}


/////////////////////////////////////////////////////////////////////////////
// CSoftDoc diagnostics

#ifdef _DEBUG
void CSoftDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSoftDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSoftDoc commands

void CSoftDoc::OnDiffusion() 
{

	int nIter;
  float constanta;
  
  DiffuseDlg diffDlg;
  diffDlg.m_newIterN = 10;
  diffDlg.m_newThr = 1;

  if (diffDlg.DoModal() == IDOK)
  {
     nIter = diffDlg.m_newIterN;
	 constanta = diffDlg.m_newThr;

     Diffusion diff = Diffusion();
     diff.SetInput(this->modelPtr);
     diff.SetStep(constanta);
     diff.SetNumberOfIteration(nIter);
     diff.Proceed();

     this->modelPtr->Translate2Origin();
     this->modelPtr->makeBoundBox();

	 POSITION pos = this->GetFirstViewPosition();
     CSoftView *theView = (CSoftView *) (this->GetNextView(pos));	 

     theView->SetupViewVolume(this->modelPtr);
     theView->drawModel(this->modelPtr);
     theView->Invalidate();
  }

}
