// softDoc.h : interface of the CSoftDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOFTDOC_H__D975A1B7_F6B7_11D4_B299_0000F45E136F__INCLUDED_)
#define AFX_SOFTDOC_H__D975A1B7_F6B7_11D4_B299_0000F45E136F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "polyData.h"
#include "fileManager.h"
#include "featureHandler.h"
#include "curvature.h"
#include "DiffuseDlg.h"


class CSoftDoc : public CDocument
{
protected: // create from serialization only
	CSoftDoc();
	DECLARE_DYNCREATE(CSoftDoc)

// Attributes
public:

   polyData *modelPtr;
   fileManager *fileMngr;
   featureHandler *feature;
   curvature *modelCurv;
   CString m_modelInfo;

 // Operations
public:

   void ClearDoc();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSoftDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSoftDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CSoftDoc)
	afx_msg void OnDiffusion();
	//}}AFX_MSG
	afx_msg void OnUpdateModelInfo(CCmdUI *pCmdUI);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SOFTDOC_H__D975A1B7_F6B7_11D4_B299_0000F45E136F__INCLUDED_)
