//transform.cpp
#include "stdafx.h"
#include "polyData.h"


typedef float  MATRIX3X3[3][3];

void UnitMatrix(MATRIX3X3 &m)
{
  m[0][0] =1; m[0][1] =0; m[0][2] =0; 
  m[1][0] =0; m[1][1] =1; m[1][2] =0;
  m[2][0] =0; m[2][1] =0; m[2][2] =1;  
}

void ZeroMatrix(MATRIX3X3 &m)
{
  m[0][0] =0; m[0][1] =0; m[0][2] =0; 
  m[1][0] =0; m[1][1] =0; m[1][2] =0;
  m[2][0] =0; m[2][1] =0; m[2][2] =0;  
}

void CopyMatrix(MATRIX3X3 &dst, MATRIX3X3 &src)
{
	for (int i=0; i<3; i++)
	{
	  for (int j=0; j<3; j++)
	  {
		dst[i][j] = src[i][j];
	  }
	}
}

void ScaleMatrix(MATRIX3X3 &dst, float &scale, MATRIX3X3 &src)
{
	for (int i=0; i<3; i++)
	{
	  for (int j=0; j<3; j++)
	  {
		dst[i][j] = scale*src[i][j];
	  }
	}
}
void TransposeMatrix(MATRIX3X3 &dst, MATRIX3X3 &src)
{
	for (int i=0; i<3; i++)
	{
	  for (int j=0; j<3; j++)
	  {
		dst[i][j] = src[j][i];
	  }
	}
}
void MultMatrix(MATRIX3X3 &product, MATRIX3X3 &m1, MATRIX3X3 &m2)
{
	for (int x=0; x<3; x++)
	{
	  for (int y=0; y<3; y++)
	  {
		  float sum = 0;
		  for (int z=0; z<3; z++)
		  {
		   sum += m1[x][z] * m2[z][y];
		  }
          product[x][y] = sum;
	  }
	}
}

void Transform(polyData *model, MATRIX3X3 &m)
{
  float newX, newY, newZ;

  for (int i=0; i<model->numPts; i++)
  {
    newX = model->Points[i][0]*m[0][0] +
		   model->Points[i][1]*m[1][0] +
		   model->Points[i][2]*m[2][0] ;

    newY = model->Points[i][0]*m[0][1] +
		   model->Points[i][1]*m[1][1] +
		   model->Points[i][2]*m[2][1] ;

    newZ = model->Points[i][0]*m[0][2] +
		   model->Points[i][1]*m[1][2] +
		   model->Points[i][2]*m[2][2] ;

    model->Points[i][0] = newX;
    model->Points[i][1] = newY;
    model->Points[i][2] = newZ;
  }
}





